function GeneralFunctions(OperatorRepository, GeneralFunctionsService, ScreenService, UtilitiesService, PrinterService,
	PermissionService, PaymentService, ImpressaoLeituraX, IntegrationService, SSLConnectionId, ParamsMenuRepository,
	FilterProducts, ItemSangria, Query, templateManager, IntegrationSiTEF, IntegrationADX8000, IntegrationGPOS720, 
	OperatorController, GetVenda, FiscalFunctions, PerifericosService, AtualizacaoDisponivel, AtualizarVersao, 
	ConfigIpRepository){

	var self = this;
	var MESSAGE_ADMINISTRATIVE_OK;
	var MESSAGE_NULL_RESPONSE = 'Não foi possível obter o retorno da integração.';
	var PAYMENT_INVOICE = "";

	if(!(String.prototype.replaceAll)){
		String.prototype.replaceAll=function(searchValue, replaceValue){
			return this.replace(new RegExp(searchValue.replace(/[.*+?^${}()|[\]\\]/g, '\\$&'), 'g'), replaceValue);
		};
	}

	
	var sitefConsts = IntegrationSiTEF.paymentTypeConstants().geral;

	// Reimpressão - Cupom Fiscal

	this.handleReprintPopup = function (widgetReimpressaoFiscalNormal) {
		self.verificaAcessoSupervisor(widgetReimpressaoFiscalNormal, 'reimpressaoFiscal').then(function(){
			for (var index = 0; index < widgetReimpressaoFiscalNormal.getField('radioReprintSaleCoupon').dataSource.data.length; index++) {
				var posicao = widgetReimpressaoFiscalNormal.getField('radioReprintSaleCoupon').dataSource.data[index];
				if(posicao.value=='U' && posicao.name.toLocaleLowerCase().indexOf("Última Venda Realizada".toLocaleLowerCase())>=0){
					widgetReimpressaoFiscalNormal.getField('radioReprintSaleCoupon').dataSource.data[index].name = 'Última Venda Realizada no caixa '+operatorData.CDCAIXA;
					break;
				}
			}
			widgetReimpressaoFiscalNormal.getField('radioReprintSaleCoupon').setValue('U');
	
			self.setSaleCodeLength(widgetReimpressaoFiscalNormal);
			self.handleReprintType(widgetReimpressaoFiscalNormal);
		});
	};

	this.setSaleCodeLength = function (widget){
		widget.getField('saleCode').maxlength = operatorData.IDTPEMISSAOFOS === 'SAT' ? 6 : 9;
	};

	this.handleReprintType = function (widget) {
		var saleCodeField = widget.getField('saleCode');
		var searchSalesField = widget.getField('searchSales');
		var radio = widget.getField('radioReprintSaleCoupon').value();
		saleCodeField.value('');
		searchSalesField.value('');

		saleCodeField.isVisible = (radio == 'C');
		searchSalesField.isVisible = (radio == 'V');

		if (radio == 'C') {
			saleCodeField.clearValue();
		} else if (radio == 'V') {
			searchSalesField.clearValue();
		}

		var searchSalesConsumerField = widget.getField('searchSalesConsumer');
		var searchSalesCpfField = widget.getField('searchSalesCPF');
		var searchSalesEmailField = widget.getField('searchSalesEmail');
		var dateField = widget.getField('date');
		var buscaField = widget.getField('buscar');

		searchSalesConsumerField.isVisible = radio === 'O' ? true : false;
		searchSalesCpfField.isVisible = radio === 'I' ? true : false;
		searchSalesEmailField.isVisible = radio === 'E' ? true : false;
		dateField.isVisible = (radio === 'O' || radio === 'E' || radio === 'I') ? true : false;
		buscaField.isVisible = (radio === 'O' || radio === 'E' || radio === 'I') ? true : false;

		saleCodeField.readOnly = radio === 'C' ? false : true;
		buscaField.readOnly = true;
		searchSalesConsumerField.readOnly = true;
		searchSalesCpfField.readOnly = true;
		searchSalesEmailField.readOnly = true;

		buscaField.clearValue();
		dateField.clearValue();

		var i=0;
		for ( i=0; i<= searchSalesConsumerField.dataSourceFilter.length;i++) {
			if(searchSalesConsumerField.dataSourceFilter[i].name=='busca'){
				searchSalesConsumerField.dataSourceFilter[i].value='';
				break;
			}
		}
		for ( i=0; i<= searchSalesCpfField.dataSourceFilter.length;i++) {
			if(searchSalesCpfField.dataSourceFilter[i].name=='busca'){
				searchSalesCpfField.dataSourceFilter[i].value='';
				break;
			}
		}
		for ( i=0; i<= searchSalesEmailField.dataSourceFilter.length;i++) {
			if(searchSalesEmailField.dataSourceFilter[i].name=='busca'){
				searchSalesEmailField.dataSourceFilter[i].value='';
				break;
			}
		}

		if (radio === 'O') {
			searchSalesConsumerField.clearValue();
		} else if (radio === 'I') {
			searchSalesCpfField.clearValue();
		} else if (radio === 'E') {
			searchSalesEmailField.clearValue();
		}
	};

	this.changeReadOnly = function (widget) {
			var saleCodeField = widget.getField('saleCode');
			var searchSalesField = widget.getField('searchSales');
			var radio = widget.getField('radioReprintSaleCoupon').value();
			saleCodeField.value('');
			searchSalesField.value('');

			var searchSalesConsumerField = widget.getField('searchSalesConsumer');
			var searchSalesCpfField = widget.getField('searchSalesCPF');
			var searchSalesEmailField = widget.getField('searchSalesEmail');
			var dateField = widget.getField('date');
			var buscaField = widget.getField('buscar');

			//valida data
			if(FiscalFunctions.validateDate(dateField)){
				buscaField.readOnly = false;

				saleCodeField.readOnly = radio === 'C' ? false : true;
				searchSalesConsumerField.readOnly = radio === 'O' ? false : true;
				searchSalesCpfField.readOnly = radio === 'I' ? false : true;
				searchSalesEmailField.readOnly = radio === 'E' ? false : true;

				if (radio === 'O') {
					searchSalesConsumerField.dataSourceFilter[0].value = dateField.value();
					searchSalesConsumerField.reload();
				} else if (radio === 'I') {
					searchSalesCpfField.dataSourceFilter[0].value = dateField.value();
					searchSalesCpfField.reload();
				} else if (radio === 'E') {
					searchSalesEmailField.dataSourceFilter[0].value = dateField.value();
					searchSalesEmailField.reload();
				}

			} else {
				ScreenService.showMessage("Data Inválida.");
			}
	};

	//Função responsavel por mudar o dataSourse dos filters da Reimpressão fiscal
	this.changeDataSource = function (widget) {
		var buscaField = widget.getField('buscar');
		var radio = widget.getField('radioReprintSaleCoupon').value();
		var saleCodeField = widget.getField('saleCode');
		var searchSalesField = widget.getField('searchSales');
		var searchSalesConsumerField = widget.getField('searchSalesConsumer');
		var searchSalesCpfField = widget.getField('searchSalesCPF');
		var searchSalesEmailField = widget.getField('searchSalesEmail');

		if(radio === 'O'){
			searchSalesConsumerField.dataSourceFilter[1].value = buscaField.value();
		 	searchSalesConsumerField.reload();
		}else if(radio === 'I'){
			searchSalesCpfField.dataSourceFilter[1].value = buscaField.value();
		 	searchSalesCpfField.reload();
		}else if(radio === 'E'){
			searchSalesEmailField.dataSourceFilter[1].value = buscaField.value();
		 	searchSalesEmailField.reload();
		}
	};

	this.openPopupEnviaCupomEmail = function (widget) {
		if(operatorData.IDENVCUPOMEMAIL=='S'){
			var widgetPayment = templateManager.container.getWidget('generalFunctions');
			var setEmailConsumerPopUp = widgetPayment.container.getWidget('setEmailConsumerPopUp');
			//pega o field do email e seta o valor dele de acordo com o email do consumidor da venda
			consumerEmail = setEmailConsumerPopUp.getField('consumerEmail');
			if(!_.isEmpty(result[0].DSEMAILENVCUPOM)){
				consumerEmail.setValue(result[0].DSEMAILENVCUPOM);
			} else if(!_.isEmpty(result[0].DSEMAILCONS)) {
				consumerEmail.setValue(result[0].DSEMAILCONS);
			} else {
				consumerEmail.clearValue();
			}
			ScreenService.openPopup(setEmailConsumerPopUp);
		} else {
			self.reprintSaleCoupon(widget, false, '');
		}
	};

	this.enviaCupomEmail = function (widget, informaEmail) {
		var popup = widget.getParent().getWidget('reprintSaleCouponPopup');
		//verifica se informou o email, caso sim, envia o cupom por email
		//caso não, segue o fluxo de reimpressão normal
		if(informaEmail){
			consumerEmail = widget.getField('consumerEmail');
			if (self.validateEmailConsumer(consumerEmail)) {
				self.reprintSaleCoupon(popup, informaEmail, consumerEmail.value());
				ScreenService.closePopup();
			}
		} else {
			self.reprintSaleCoupon(popup, informaEmail, '');
		}
	};

	this.validateEmailConsumer = function(field) {
		if (!field.widget.isValid()){
            ScreenService.showMessage("Favor preencha o e-mail.");
        }
		if (!UtilitiesService.checkEmail(field.value())){
			ScreenService.showMessage('E-mail inválido.<br><br>Verifique e tente novamente.');
            return false;
		}
        return true;
	};

	this.reprintPedido = function () {
		self.verificaAcessoSupervisor('', 'reimpressaoFiscal').then(function(){
				GeneralFunctionsService.reprintPedido(operatorData.modoHabilitado).then(function (result) {
					if(result[0]){
						if (result[0].error) {
							ScreenService.showMessage(result[0].message, 'alert');
						}
					} else {
						if(!_.isEmpty(result.ReprintPedido.text)){
    	    	            var text = result.ReprintPedido.text.slice(0, result.ReprintPedido.text.length - 38);
    	    	            PrinterService.printerCommand(PrinterService.TEXT_COMMAND, text);
    	    	            var space = (operatorData.IDTPEMISSAOFOS  === 'SAT') ? 2 : 0;
    	    	            space = operatorData.IDHABCAIXAVENDA === 'FOS' ? space + 1 : space;
    	    	            for (var i = 0; i < space; i++) {
    	    	                PrinterService.printerSpaceCommand();
    	    	            }
    	    	            PrinterService.printerInit('25').then(function (result) {
    	    	                if (result.error) { ScreenService.alertNotification(result.message); }
    	    	            });
    	    	        } else {
    	    	            PerifericosService.printTableOrder(result.ReprintPedido.paramsImpressora).then(function (res) {
    	    	                if (!_.isEmpty(result.ReprintPedido.paramsImpressora)) {
										result.ReprintPedido.paramsImpressora[0].comandos.forEach(function (comandosImpressao){
		    	    	                       PrinterService.printerCommand(PrinterService.TEXT_COMMAND, comandosImpressao.parameters.text);
		    	    	                });
		
	    	    	                PrinterService.printerInit('25').then(function (result) {
	    	    	                    if (result.error){ ScreenService.alertNotification(result.message); }
	    	    	                }.bind(this));
	    	    	              }
	    	    	        });
							ScreenService.hideLoader();
	    	    	    }
					}
				});
		});
	};

	this.reprintSaleCoupon = function (widget, informaEmail, consumerEmail) {
		var reprintType = widget.getField('radioReprintSaleCoupon').value();
		var saleCode = widget.getField('saleCode').value();
		var searchSales = widget.getField('searchSales').value();

		if (reprintType === 'V') {
			searchSales = widget.getField('searchSales').value();
		} else if(reprintType === 'O'){
			searchSales = widget.getField('searchSalesConsumer').value();
		}else if(reprintType === 'I'){
			searchSales = widget.getField('searchSalesCPF').value();
		}else if(reprintType === 'E'){
			searchSales = widget.getField('searchSalesEmail').value();
		}

		var fieldsearchSales = null;
		if(widget.getField('searchSales')){
			fieldsearchSales = widget.getField('searchSales');
		}

		var cdcaixa = 'T';

		if(saleCode){
			if(saleCode.indexOf(' - ')>=1){
				cdcaixa = saleCode.split(' - ')[1];
				saleCode = saleCode.split(' - ')[0];
			}
		}
		if(searchSales){
			if(searchSales.indexOf(' - ')>=1){
				cdcaixa = searchSales.split(' - ')[1];
				saleCode = searchSales.split(' - ')[0];
				searchSales = searchSales.split(' - ')[0];
			}
		}

		saleCode = _.isEmpty(saleCode) ? searchSales : saleCode;

		if ( reprintType == 'U' || saleCode){			
			saleCode = UtilitiesService.padLeft(saleCode, widget.getField('saleCode').maxlength, '0');
			if(reprintType=='U'){ cdcaixa = reprintType; }
			GeneralFunctionsService.validaNotaPorCupom(saleCode, (cdcaixa||'T')).then(function(vendas){
				if(vendas.length < 1){
					ScreenService.showMessage('Os dados da venda não foram encontrados.', 'alert');
				} else if(vendas.length > 1){
					if(fieldsearchSales){
						fieldsearchSales.dataSource.setData(vendas);
						fieldsearchSales.dataSource.data = vendas;
						if(!fieldsearchSales.openField){
							fieldsearchSales.isVisible = true;
							fieldsearchSales.reload().then(function(){
								fieldsearchSales.openField();
								fieldsearchSales.isVisible = false;
								ScreenService.showMessage("Há mais de uma venda para o número de Nota Fiscal informado.", 'alert').then(function(){
									fieldsearchSales.dataSource.setData(vendas);
									fieldsearchSales.dataSource.data = vendas;							
								});
							});
						} else {
							fieldsearchSales.openField();
							ScreenService.showMessage("Há mais de uma venda para o número de Nota Fiscal informado.", 'alert').then(function(){
								fieldsearchSales.dataSource.setData(vendas);
								fieldsearchSales.dataSource.data = vendas;							
							});
						}
					}
				} else {
					if(reprintType == 'C'){
						vendastemp = vendas[0];
						cdcaixa = vendastemp.CDCAIXA;
					}
					GeneralFunctionsService.reprintSaleCoupon(reprintType, saleCode, informaEmail, consumerEmail, cdcaixa).then(function (result) {
						result = result||{};
						result = result[0]||{};
						if (result.error){
							ScreenService.showMessage(result.message, 'alert');
						} else {
							result = result.dadosImpressao;
							if (informaEmail == true) {
								ScreenService.showMessage('Operação realizada com sucesso.<br>O e-mail será enviado assim que as vendas forem exportadas.');
								ScreenService.closePopup();
							} else 	if (result.paramsImpressora) {
								PerifericosService.print(result.paramsImpressora).then(function () {
									if(result.IDUTILIMPFRONT){
										ScreenService.closePopup();
									} else {
										PaymentService.handlePrintReceipt(result.dadosImpressao);
										ScreenService.closePopup();
									}
								});
							} else 	if (result.IDUTILIMPFRONT) {
								var param = {};
								param.comandos =result.comandos;
								param.IDUTILIMPFRONT =result.IDUTILIMPFRONT;
								param.impressora = {};
								param.impressora = result.dadosImpressao;
								PerifericosService.print(param).then(function () {
									ScreenService.closePopup();
								});
							} else {
								if (_.isEmpty(result.dadosImpressao)) {
									result.dadosImpressao = result;
								}
								PaymentService.handlePrintReceipt(result.dadosImpressao);
								ScreenService.closePopup();
							}
						}
					});
				}
			});
		} else {
			ScreenService.showMessage('Código do cupom fiscal inválido.', 'alert');
		}
	};

	// Reimpressão - Cupom TEF
	this.openPopupReprintTef = function (widget) {
		PermissionService.checkAccess('administracaoTEF').then(function () {
			/*if(widget.getField('radioReprintTefCoupon')){
				for (var index = 0; index < widget.getField('radioReprintTefCoupon').dataSource.data.length; index++) {
					if(widget.getField('radioReprintTefCoupon').dataSource.data[index].value=='P'){
						widget.getField('radioReprintTefCoupon').dataSource.data[index].name="Pesquisar Cupons - caixa "+operatorData.CDCAIXA;
						break;
					}
				}
			}*/
			ScreenService.openPopup(widget);
		});
	};

	this.handleReprintTefType = function (widget, setOnEnter) {
		var nsuSitefField = widget.getField('nsuSitef');
		var transactionDateField = widget.getField('transactionDate');
		var transactionAuthField = widget.getField('transactionAuth');
		var transactionViaField = widget.getField('transactionVia');
		var radioReprintTefCoupon = widget.getField('radioReprintTefCoupon');

		if (setOnEnter)
			radioReprintTefCoupon.setValue('U');

		nsuSitefField.clearValue();
		transactionDateField.clearValue();
		transactionViaField.clearValue();

		transactionAuthField.isVisible = radioReprintTefCoupon.value() == 'P' || radioReprintTefCoupon.value() == 'C' || radioReprintTefCoupon.value() == 'T';
		transactionViaField.isVisible = transactionAuthField.isVisible;
		widget.getField("searchPayments").isVisible = (radioReprintTefCoupon.value() == 'P' || radioReprintTefCoupon.value() == 'T');
		
		widget.getField("searchPayments").dataSourceFilter[0].value=radioReprintTefCoupon.value();

		nsuSitefField.isVisible = radioReprintTefCoupon.value() == 'C';
		transactionDateField.isVisible = nsuSitefField.isVisible;
		self.transactionAuthOnChange(widget);

		if (!setOnEnter)
			self.updateFields(widget.fields);
	};

	this.updateFields = function (fields) {
		fields.forEach(function (field) {
			if (field.isVisible && !field.readOnly) {
				field.validations = { "required": {} };
			} else {
				field.validations = "";
			}

			if (field.name !== 'radioReprintTefCoupon') {
				field.clearValue();
				field.reload();
			}
		});
	};

	this.reprintTEFVoucher = function (widget) {
		if (widget.isValid()) {
			window.returnIntegration = _.bind(self.getReprintTextResult, this);

			var instanciaTEF = window.getInstanciaTEF();
			if (instanciaTEF) {
				self.getSitefParameters().then(function (paymentParams) {
					paymentParams.paymentType = widget.getField('radioReprintTefCoupon').value() === 'U' ? sitefConsts.reimpressaoUltimo : sitefConsts.reimpressaoEspecifica;
					paymentParams = self.handleReprintTef(widget, paymentParams);

					if(operatorData.IDTPTEF == '5' || operatorData.IDTPTEF == 'D' || operatorData.IDTPTEF == 'F') {
						IntegrationSiTEF.initSitefProcess(paymentParams);
					} else if (paymentParams.paymentType === sitefConsts.reimpressaoEspecifica) {
						IntegrationSiTEF.initSitefProcess(paymentParams);
					}
				});
			} else {
				//window.returnIntegration(self.invalidPrinterInstance());
				var arrResposta = self.invalidPrinterInstance();
				arrResposta.error = true;
				arrResposta.message = "Esta funcionalidade ainda não foi implementada para este dispositivo.";
			}
		}
	};

	this.handleReprintTef = function (widget, paymentParams) {
		var now = new Date();
		var year = now.getFullYear().toString();
		var month = self.leftZero(now.getMonth() + 1);
		var day = self.leftZero(now.getDate());
		var hour = self.leftZero(now.getHours());
		var minutes = self.leftZero(now.getMinutes());
		var seconds = self.leftZero(now.getSeconds());
		self.PAYMENT_INVOICE = year + month + day + hour + minutes + seconds;

		if (widget.getField('radioReprintTefCoupon').value() !== 'U') {
			var row = widget.currentRow;
			paymentParams.paymentInvoice = self.PAYMENT_INVOICE;
			paymentParams.paymentDate = row.transactionDate.split(" ")[0].replace('/', '').replace('/', '');
			paymentParams.paymentNSU = row.nsuSitef;
			paymentParams.paymentValue = row.VRMOVIVEND;
			paymentParams.paymentAuth = row.transactionAuth||"1";
			paymentParams.paymentVia = row.transactionVia||"1";
		} else {
			paymentParams.paymentInvoice = self.PAYMENT_INVOICE;
			paymentParams.paymentDate = paymentParams.paymentNSU = paymentParams.paymentAuth = paymentParams.paymentVia = "";
		}

		return paymentParams;
	};

	this.leftZero = function(leftZero){
		if(leftZero < 10)
			leftZero = "0" + leftZero;

		return leftZero;
	};

	// Registro de terminal
	this.terminalRegister = function () {
		ScreenService.showLoader();
		window.returnIntegration = _.bind(self.returnAdministrativeMenu, this, true);

		if (IntegrationSiTEF.getInstance()){
			MESSAGE_ADMINISTRATIVE_OK = "Terminal Registrado com Sucesso.";
			
			self.getSitefParameters().then(function(sitefParams){
				sitefParams.paymentType = sitefConsts.registroTerminal;

				IntegrationSiTEF.initSitefProcess(sitefParams);
			}.bind(this));
		} else {
			window.returnIntegration(self.invalidIntegrationInstance());
		}
	};

	// Transações pendentes
	this.transacoesPendentes = function () {
		ScreenService.showLoader();
		window.returnIntegration = _.bind(self.returnPendingTransactions, this);

		if (IntegrationSiTEF.getInstance()){			
			self.getSitefParameters().then(function(sitefParams){
				sitefParams.paymentType = sitefConsts.transacoesPendentes;

				IntegrationSiTEF.initSitefProcess(sitefParams);
			}.bind(this));
		} else {
			window.returnIntegration(self.invalidIntegrationInstance());
		}
	};

	this.getReprintTextResult = function (javaResult) {
		if(typeof(javaResult) === 'string') {
			javaResult = JSON.parse(javaResult);
		}
		ScreenService.closePopup();
		if (!javaResult.error) {
			javaResult = javaResult.data||{};
			javaResult.merchantReceipt = javaResult.merchantReceipt||"";
			javaResult.customerReceipt = javaResult.customerReceipt||"";
			PaymentService.printTEFVoucher(self.handlePrintText(javaResult));
		} else {
			ScreenService.showMessage(javaResult.message||javaResult.userMessage||'');
		}
	};

	this.handlePrintText = function (reprintObject) {
		return Array({
			'STLPRIVIA': reprintObject.customerReceipt,
			'STLSEGVIA': reprintObject.merchantReceipt
		});
	};

	this.transactionAuthOnChange = function (widget) {
		var transactionViaField = widget.getField("transactionVia");
		transactionViaField.readOnly = widget.currentRow.transactionAuth !== "2";
		transactionViaField.validations = transactionViaField.readOnly ? "" : { "required": {} };
		widget.currentRow.transactionVia = transactionViaField.readOnly ? "" : widget.currentRow.transactionVia;
		transactionViaField.reload();
	};

	// Teste de Comunicação
	this.sitefComunicateTest = function () {
		PermissionService.checkAccess('administracaoTEF').then(function() {
			ScreenService.showLoader();
			window.returnIntegration = _.bind(self.returnAdministrativeMenu, this, false);

			if (IntegrationSiTEF.getInstance()){
				MESSAGE_ADMINISTRATIVE_OK = "Teste de Comunicação OK.";
				
				self.getSitefParameters().then(function(sitefParams){
					sitefParams.paymentType = sitefConsts.testeComunicacao;

					IntegrationSiTEF.configureWindowFunctions();
					try {IntegrationSiTEF.instance.payment(JSON.stringify(sitefParams));}
					catch(e) {
						try {IntegrationSiTEF.instance.payment(JSON.stringify(sitefParams), window.returnIntegration, null);}
						catch(err) {window.returnIntegration(self.invalidIntegrationInstance());}
					}
				}.bind(this));
			} else {
				window.returnIntegration(self.invalidIntegrationInstance());
			}
		}.bind(this));
	};

	// Recarga de Tabelas
	this.sitefTableLoad = function () {
		ScreenService.showLoader();
		window.returnIntegration = _.bind(self.returnAdministrativeMenu, this, true);

		if (IntegrationSiTEF.getInstance()){
			MESSAGE_ADMINISTRATIVE_OK = "Tabelas Carregadas com Sucesso.";
			
			self.getSitefParameters().then(function(sitefParams){
				sitefParams.paymentType = sitefConsts.carregaTabelas;

				IntegrationSiTEF.initSitefProcess(sitefParams);
			}.bind(this));
		} else {
			window.returnIntegration(self.invalidIntegrationInstance());
		}
	};

	// Envio de Logs para servidor SiTef
	this.sendSitefLog = function () {
		ScreenService.showLoader();
		window.returnIntegration = _.bind(self.returnAdministrativeMenu, this, true);

		if (IntegrationSiTEF.getInstance()){
			MESSAGE_ADMINISTRATIVE_OK = "Logs Enviados com Sucesso.";

			self.getSitefParameters().then(function(sitefParams){
				sitefParams.paymentType = sitefConsts.enviaLogs;
				
				IntegrationSiTEF.initSitefProcess(sitefParams);
			}.bind(this));
		} else {
			window.returnIntegration(self.invalidIntegrationInstance());
		}
	};

	// Estorno
	this.reversalPayment = function (widget) {
		if (widget.isValid()) {
			if (self.validateValue(widget.getField('VRMOVIVEND'))) {
				if (self.validateDate(widget)) {
					ScreenService.showLoader();
					widget.currentRow.CDNSUHOSTTEF = self.validateNSU(widget);
					var row = widget.currentRow;
					var date = _.clone(row.TRANSACTIONDATE);

					while (date.search('/') != -1) {
						date = date.replace('/', '');
					}

						GeneralFunctionsService.getNrControlTef(operatorData.CDFILIAL, operatorData.CDCAIXA, row.CDNSUHOSTTEF).then(function (result) {
							result = result[0];

							if (result.error) {
								ScreenService.showMessage(result.message);
								ScreenService.hideLoader();
							} else {
								let nrControlTef = parseInt(result.data.NRCONTROLTEF, 10);
								nrControlTef += 1;
								result.data.NRCONTROLTEF = nrControlTef.toString();
								IntegrationService.reversalIntegration(self.mochRemovePaymentSale,
									Array({
										'IDTIPORECE': row.IDTIPORECE,
										'VRMOVIVEND': parseFloat(row.VRMOVIVEND.split('.').join('').replace(',', '.')),
										'DSENDIPSITEF': operatorData.DSENDIPSITEF,
										'DSENDIPSITEF2': operatorData.DSENDIPSITEF2,
										'CDLOJATEF': operatorData.CDLOJATEF,
										'CDTERTEF': operatorData.CDTERTEF,
										'TRANSACTIONDATE': date,
										'CDNSUHOSTTEF': row.CDNSUHOSTTEF,
										'NRCONTROLTEF': result.data.NRCONTROLTEF,
										'IDTPTEF': operatorData.IDTPTEF,
										'NRCARTBANCO': result.data.NRCARTBANCO
									})
								).then(self.reversalPaymentResult);
							}
						}.bind(this),
							function (err) {
								ScreenService.hideLoader();
							});
				}
			}
		}
	};

	this.returnPendingTransactions = function (javaResult) {
        ScreenService.hideLoader();

        if (!javaResult.error && (!_.isEmpty(javaResult.data.paymentData) && !_.isEmpty(javaResult.data.paymentHour))) {
			var pendingParams = {
				TRANSACTIONDATE : javaResult.data.paymentData,
				INVOICE : javaResult.data.paymentInvoice,
				PAYMENTHOUR: javaResult.data.paymentHour,
			};

			window.returnIntegration = _.bind(self.returnCancelPending, this);

			IntegrationSiTEF.cancelPending(pendingParams);
            ScreenService.showMessage(MESSAGE_ADMINISTRATIVE_OK, 'SUCCESS');
        } else {
			ScreenService.closePopup();
			ScreenService.showMessage('Nenhuma transação retornada para cancelar', 'SUCCESS');
		}
			
    };

	this.returnCancelPending = function (javaResult) {
		ScreenService.closePopup();

        if (!javaResult.error) {
            ScreenService.showMessage("Transações pendentes canceladas com sucesso.", 'SUCCESS');
        } else {
			ScreenService.showMessage("Erro ao cancelar pendencias.", 'SUCCESS');
		}
    };

	this.mochRemovePaymentSale = function () {
		return new Promise.resolve(true);
	};

	this.reversalPaymentResult = function (javaResult) {
		ScreenService.hideLoader();

		if (!javaResult.error) {
			PaymentService.printTEFVoucher(javaResult.data);
			ScreenService.closePopup();
			ScreenService.showMessage("TEF estornado com sucesso.", 'success');
		} else {
			ScreenService.showMessage(javaResult.userMessage || javaResult.message);
		}
	};

	this.openPopupReversalTef = function (widget) {
		PermissionService.checkAccess('administracaoTEF').then(function () {
			var date = new Date().toLocaleDateString('pt-BR');
			widget.getField("TRANSACTIONDATE").setValue(date);
			widget.getField("IDTIPORECE").setValue("1");
			widget.getField("VRMOVIVEND").setValue("");
			widget.getField("CDNSUHOSTTEF").setValue("");

			ScreenService.openPopup(widget);
		}.bind(this));
	};

	this.validateNSU = function (widget) {
        var CDNSUHOSTTEF = widget.currentRow.CDNSUHOSTTEF;

        if(widget.currentRow.IDTIPORECE == 'H') {
            CDNSUHOSTTEF = UtilitiesService.padLeft(CDNSUHOSTTEF, 20, '0');
        } else {
            CDNSUHOSTTEF = UtilitiesService.padLeft(CDNSUHOSTTEF, 9, '0');
        }

        return CDNSUHOSTTEF;
    };

	this.validateValue = function (field) {
		var value = parseFloat(field.value());

		if (isNaN(value)) {
			ScreenService.showMessage('Valor inválido.', 'alert');
			return false;
		}

		return true;
	};

	this.returnAdministrativeMenu = function (closeUI, javaResult) {
        ScreenService.hideLoader();

        if (closeUI)
            ScreenService.closePopup();

        if (!!javaResult.error && javaResult.showErrorMessage) {
            ScreenService.showMessage(javaResult.message);
        } else if (!javaResult.error) {
            ScreenService.showMessage(MESSAGE_ADMINISTRATIVE_OK, 'SUCCESS');
        }
    };

	this.validateDate = function (widget) {
		var date = _.clone(widget.currentRow.TRANSACTIONDATE);
		date = date.split('/');

		var day = parseInt(date[0]);
		var month = parseInt(date[1]);
		var year = parseInt(date[2]);

		if (month >= 1 && month <= 12) {
			var february = self.leapYear(year) ? 29 : 28;
			var monthLength = [31, february, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];

			if (day >= 1 && day <= monthLength[month - 1]) {
				if (year <= (new Date()).getFullYear())
					return true;
			}
		}

		ScreenService.showMessage("Data inválida");
		widget.currentRow.TRANSACTIONDATE = '';
		return false;
	};

	this.leapYear = function (year) {
		if (year % 4 === 0) {
			if (year % 100 === 0) {
				if (year % 400 === 0) {
					return true;
				} else {
					return false;
				}
			} else {
				return true;
			}
		} else {
			return false;
		}
	};

	this.maskDate = function (field) {
		var date = field.value();
		date = date.replace(/\D/g, '');
		var m = date.match(/(\d{0,2})(\d{0,2})(\d{0,4})/);

		if (m[1] > 0) {
			if (m[2] > 0) {
				if (m[3] > 0) {
					date = m[1] + '/' + m[2] + '/' + m[3];
				} else {
					date = m[1] + '/' + m[2];
				}
			}
		}

		field.setValue(date);
	};

	this.getSitefParameters = function () {
		return SSLConnectionId.findOne().then(function (sSLConnectionIdResponse) {
				var paymentParams = {
					'paymentIp': operatorData.DSENDIPSITEF,
					'paymentIp2': operatorData.DSENDIPSITEF2,
					'CDTPCOMUNTLS': operatorData.CDTPCOMUNTLS,
					'CDTOKENTLS': operatorData.CDTOKENTLS,
					'CDTPPROXYTLS': operatorData.CDTPPROXYTLS,
					'CDENPROXYTLS': operatorData.CDENPROXYTLS,
					'paymentTerminal': operatorData.CDTERTEF,
					'paymentStore': operatorData.CDLOJATEF,
					'storeCnpj': operatorData.NRINSJURFILI,
					'IDUTLSSL': operatorData.IDUTLSSL,
					'IDCODSSL': '',
					'paymentValue': '',
					'paymentInvoice': '',
					'paymentHour': '',
					'paymentOperator': '',
					'paymentDate': '',
					'paymentNSU': '',
					'paymentAuth': '',
					'paymentVia': '',
					'razaoSocial': operatorData.NMRAZSOCFILI,
					'acessibilidadeVisual':'0'
				};

				if (sSLConnectionIdResponse) {
					paymentParams.IDCODSSL = sSLConnectionIdResponse.IDCODSSL;
				}

				return paymentParams;
		});
	};

	this.invalidPrinterInstance = function () {
		return {
			'error': true,
			'message': 'Não foi possível chamar a impressora. Sua instância não existe.'
		};
	};

	this.invalidIntegrationInstance = function () {
		return {
			'error': true,
			'message': 'Não foi possível chamar a integração. Sua instância não existe.'
		};
	};

	this.generalFunctionsOnEnter = function (widget) {
		OperatorRepository.findOne().then(function (operatorData) {
			var showSitefFunctions = operatorData.IDTPTEF === '5' || operatorData.IDTPTEF === 'D' || operatorData.IDTPTEF === 'F';

			widget.getField("reprintOfTEFCoupon").isVisible = showSitefFunctions;
			widget.getField("comunicateTest").isVisible = showSitefFunctions;
			widget.getField("tableLoad").isVisible = showSitefFunctions;
			widget.getField("sendSitefLog").isVisible = showSitefFunctions;
			widget.getField("terminalRegister").isVisible = showSitefFunctions;
			widget.getField("transacoesPendentes").isVisible = showSitefFunctions;
			widget.getField("qrCodeSale").isVisible = operatorData.modoHabilitado === 'B' && operatorData.IDLEITURAQRCODE === 'S';
			widget.getField("reversalPayment").isVisible = showSitefFunctions;
			widget.getField("sendLogs").isVisible = showSitefFunctions;

			var showRedeFunctions = operatorData.IDTPTEF === '4';
			widget.getField("reprintOfRedeTEFCoupon").isVisible = showRedeFunctions;
			widget.getField("redeReversalPayment").isVisible = showRedeFunctions;

			widget.getField("checkPendindPayments").isVisible = operatorData.modoHabilitado === 'B';
		});
	};

	this.blockProducts = function (widget) {
		if (widget.isValid()) {
			if (!_.isEmpty(widget.currentRow.selectProducts)) {
				GeneralFunctionsService.blockProducts(widget).then(function (blockProductResult) {
					if (!blockProductResult[0].error) {
						self.setBlockUnblock(widget.currentRow.selectProducts);
						ScreenService.showMessage("Produto(s) bloqueado(s).");
						widget.getField("selectProducts").clearValue();
						ScreenService.closePopup(widget);
					} else {
						ScreenService.showMessage(blockProductResult[0].message);
					}
				}.bind(this));
			}
			else {
				ScreenService.showMessage("Favor escolher pelo menos um produto.", "alert");
			}
		}
	};

	this.setBlockUnblock = function (products) {
		ParamsMenuRepository.findAll().then(function (menuProducts) {
			menuProducts.forEach(function (menuProduct) {
				products.forEach(function (product) {
					if (menuProduct.CDPRODUTO == product) {
						menuProduct.IDPRODBLOQ = menuProduct.IDPRODBLOQ == 'N' ? 'S' : 'N';
					}
				});
			});

			ParamsMenuRepository.save(menuProducts);
		}.bind(this));
	};

	this.unblockProducts = function (widget) {
		if (widget.isValid()) {
			if (!_.isEmpty(widget.currentRow.selectBlockedProducts)) {
				GeneralFunctionsService.unblockProducts(widget).then(function (unblockProductResult) {
					if (!unblockProductResult[0].error) {
						self.setBlockUnblock(widget.currentRow.selectBlockedProducts);
						ScreenService.showMessage("Produto(s) desbloqueado(s).");
						widget.getField("selectBlockedProducts").clearValue();
						ScreenService.closePopup(widget);
					} else {
						ScreenService.showMessage(unblockProductResult[0].message);
					}
				}.bind(this));
			}
			else {
				ScreenService.showMessage("Favor escolher pelo menos um produto.", "alert");
			}
		}
	};

	// Funcao para verificar acesso de supervisor a função de carregamento de tabelas da SITEF
	this.supervisorCarregamentoTabSitef = function (widget) {
		PermissionService.checkAccess('administracaoTEF').then(function () {
			self.sitefTableLoad();
		});
	};

	// Funcao Generica para verificar acesso de supervisor para determinado nivel de acesso
	this.verificaAcessoSupervisor = function (widget, acesso) {
		return PermissionService.checkAccess(acesso).then(function () {
			if(widget){ScreenService.openPopup(widget);}
		});
	};

	// Funcao Generica para limpar Field informada
	this.clearField = function (widget, field) {
		widget.getField(field).clearValue();
	};

	this.impressaoLeituraX = function (widget) {
		PermissionService.checkAccess('leituraX').then(function () {
			ScreenService.confirmMessage('Deseja imprimir o relatório da Leitura X?', 'question', function () {
				if (widget.isValid()) {
					GeneralFunctionsService.impressaoLeituraX().then(function (impressaoLeituraX) {
						impressaoLeituraX = impressaoLeituraX[0];
						if (impressaoLeituraX.error) {
							ScreenService.showMessage(impressaoLeituraX.message);
						} else if (impressaoLeituraX.dadosImpressao.parcial) {
							self.openPopupXReport(widget, impressaoLeituraX.dadosImpressao.parcial);
						} else if(impressaoLeituraX.IDUTILIMPFRONT) {
							PerifericosService.print(impressaoLeituraX).then(function(){});
						}
					});
				}
			});
		}.bind(this));
	};

	this.scanSaleCode = function (widget) {
		OperatorRepository.findOne().then(function (operatorData) {
			UtilitiesService.callQRScanner().then(function (qrCode) {
				if (!qrCode.error) {
					qrCode = qrCode.contents;

					if (_.isEmpty(qrCode)) {
						ScreenService.showMessage("Não foi possível obter os dados do leitor.");
					}
					else {
						widget.currentRow.qrCode = qrCode;
						widget.currentRow.chave = operatorData.chave;
						var cpfPopup = widget.container.getWidget('cpfPopup');
						cpfPopup.getField('CPF').clearValue();
						PaymentService.updateSaleCode();
						ScreenService.openPopup(cpfPopup);
					}
				} else {
					ScreenService.showMessage(qrCode.message, 'alert');
				}
			}.bind(this));
		}.bind(this));
	};

	this.qrCodeSale = function (row, generalWidget) {
		var CPF = row.CPF.replace(/[^0-9 ]/g, "");

		if (_.isEmpty(CPF) || UtilitiesService.isValidCPForCNPJ(CPF)) {
			PaymentService.qrCodeSale(generalWidget.currentRow.chave, generalWidget.currentRow.qrCode, CPF).then(function (saleResult) {
				saleResult = saleResult[0];
				if (saleResult.error) {
					ScreenService.showMessage(saleResult.message, 'alert');
					if (_.get(saleResult, 'resetSaleCode')) {
						PaymentService.updateSaleCode();
					}
				}
				else {
					PaymentService.handlePrintReceipt(saleResult.dadosImpressao);
					self.payAccountFinish(saleResult);
					ScreenService.closePopup();
				}
			});
		}
		else {
			ScreenService.showMessage('CPF inválido.');
		}
	};

	this.payAccountFinish = function (payAccount) {
		var message = 'Venda realizada. ';

		if (_.get(payAccount, 'IDSTATUSNFCE') === 'P') {
			message += '<br><br>' + 'NFCE emitido em modo de contigência.';
		}
		if (_.get(payAccount, 'mensagemNfce')) {
			message += '<br>' + _.get(payAccount, 'mensagemNfce');
		}
		if (_.get(payAccount, 'mensagemImpressao')) {
			message += '<br><br>' + _.get(payAccount, 'mensagemImpressao');
		}
		ScreenService.showMessage(message);
	};

	this.openPopupXReport = function (widget, parcial) {
		var widgetReport = widget.container.getWidget('report');
		//if(operatorData.IDUTILIMPFRONT == 'S'){ return; }
		if (operatorData.IDMODEIMPRES == '25') {
			parcial = _.join(_.split(parcial, ' | '), "\n");
		}
		widgetReport.setCurrentRow({ 'report': parcial });
		ScreenService.openPopup(widgetReport);
	};

	this.printXReport = function () {
		ImpressaoLeituraX.findOne().then(function (impressaoLeituraX) {
			PrinterService.printerCommand(PrinterService.TEXT_COMMAND, impressaoLeituraX.dadosImpressao.parcial);
			PrinterService.printerSpaceCommand();
			PrinterService.printerInit().then(function (result) {
				if (result.error)
					ScreenService.alertNotification(result.message);
			});

			ScreenService.closePopup();
		});
	};

	this.handleEnterButton = function (args) {
		var keyCode = args.e.keyCode;
		if (keyCode === 13 || keyCode === 9) {
			UtilitiesService.handleCloseKeyboard();
			var field = args.owner.field;
			var widget = field.widget;

			if (widget.name === 'reprintSaleCouponPopup') {
				self.reprintSaleCoupon(widget, false, '');
			} else if (widget.name === 'setEmailConsumerPopUp') {
				self.enviaCupomEmail(widget, true);
			} else if (widget.name === 'unlockDeviceWidget') {
				if (field.name === 'supervisor') {
					if (!Util.isDesktop()) document.getElementById('pass').focus();
				} else if (field.name === 'pass') {
					self.handleUnlockDevice(widget.currentRow);
				}
			} else if (widget.name == 'sitefPayment') {
				IntegrationSiTEF.continueSitefProcess(widget.currentRow.userInput);
			}
		}
	};

	this.setSale = function (row, widget) {
		var popup = null;
		if(widget.getParent()){
			popup = widget.getParent().getWidget('reprintSaleCouponPopup');
		}
		if(popup){
			var radio = popup.getField('radioReprintSaleCoupon').value();
			if(radio == 'V'){
				popup.getField('searchSales').value(row.NRNOTAFISCALCE+' - '+row.CDCAIXA);
			} else if(radio == 'O'){
				popup.getField('searchSalesConsumer').value(row.NRNOTAFISCALCE+' - '+row.CDCAIXA);
			} else if(radio == 'I'){
				popup.getField('searchSalesCPF').value(row.NRNOTAFISCALCE+' - '+row.CDCAIXA);
			} else if(radio == 'E'){
				popup.getField('searchSalesEmail').value(row.NRNOTAFISCALCE+' - '+row.CDCAIXA);
			} else {
				popup.getField('searchSales').value(row.NRNOTAFISCALCE +' - '+row.CDCAIXA);
				popup.getField('searchSales').value(row.NRNOTAFISCALCE+' - '+row.CDCAIXA);
			}

			if(popup.getField('saleCode')){
				popup.getField('saleCode').value(row.NRNOTAFISCALCE +' - '+row.CDCAIXA);
				popup.getField('saleCode').setValue(row.NRNOTAFISCALCE +' - '+row.CDCAIXA);
			}
		}
	};

	this.getChecked = function (widget) {
		if (!_.isEmpty(FilterProducts.checkedRows)) {
			_.forEach(widget.dataSource.data, function (dataRow) {
				_.forEach(FilterProducts.checkedRows, function (checkedRow) {
					if (dataRow.CDPRODUTO == checkedRow.CDPRODUTO) {
						dataRow.__isSelected = checkedRow.__isSelected;
					}
				});
			});

			widget.setCurrentRow(FilterProducts.checkedRows);
		}
	};

	this.clearChecked = function () {
		FilterProducts.checkedRows = Array();
	};

	this.checkControl = function (widget) {
		row = widget.selectedRow;

		if (row.__index == undefined) {
			self.gridCheck(row);
		} else {
			if (row.__index >= 0) {
				self.gridCheck(row);
			}
		}
	};

	this.gridCheck = function (row) {
		if (row.__isSelected) {
			FilterProducts.checkedRows = _.concat(FilterProducts.checkedRows, row);
		} else {
			_.remove(FilterProducts.checkedRows, function (n) {
				return n.CDPRODUTO == row.CDPRODUTO;
			});
		}
	};

	this.updateSelectField = function (field) {
		var data = Array();
		field.dataSource.data = FilterProducts.checkedRows;
		_.forEach(FilterProducts.checkedRows, function (row) {
			data = _.concat(data, row.CDPRODUTO);
		}.bind(this));
		field.setValue(data);
	};

	this.clearFilter = function (widget) {
		widget.setCurrentRow({});
		widget.getField('selectProducts').dataSourceFilter = [];
	};

	this.handleCancelReprintTef = function (widget) {
		widget.fields.forEach(function (field) {
			if (field.name === 'radioReprintTefCoupon') {
				field.setValue('U');
			} else {
				field.clearValue();
				field.isVisible = false;
			}
		});

		ScreenService.closePopup();
	};

	this.hideSearchButton = function (selectWidget) {
		selectWidget.floatingControl.searchAction = false;
		selectWidget.reload();
	};

	this.addSangria = function (widget) {
		ItemSangria.findAll().then(function (item) {
			if (widget.isValid()) {
				var tipoRecebimento = widget.getField('tipoRecebimento').value();
				var valorSangria = widget.getField('valorSangria').value();
				var tipoSangria = !!widget.getField('tipoSangria').value() ? widget.getField('tipoSangria').value() : null;
				var obsSangria = !!widget.getField('obsSangria').value() ? widget.getField('obsSangria').value() : null;
				var CDTIPORECE = widget.currentRow.CDTIPORECE;
				var CDTPSANGRIA = widget.currentRow.CDTPSANGRIA;
				var IDENTIFICADOR = item.length > 0 ? _.maxBy(item, function (a) { return a.IDENTIFICADOR; }).IDENTIFICADOR + 1 : 0;

				var itemAtual = {
					tipoRecebimento: tipoRecebimento,
					valorSangria: valorSangria,
					tipoSangria: tipoSangria,
					obsSangria: obsSangria,
					CDTIPORECE: CDTIPORECE,
					CDTPSANGRIA: CDTPSANGRIA,
					IDENTIFICADOR: IDENTIFICADOR
				};

				item = _.concat(item, itemAtual);
				self.clearPopUpSangria(widget, false);

				ItemSangria.save(item).then(function (a) {
					widget.widgets[0].dataSource.data = a;
				});
			} else {
				ScreenService.showMessage('Nem todos os campos requeridos foram informados.', 'alert');
			}
		});
	};

	this.handleRequires = function (widget) {
		OperatorRepository.findOne().then(function (operatorData) {
			if (operatorData.IDSOLTPSANGRIACX === 'N') {
				widget.getField('tipoSangria').validations = null;
			}
		});
	};

	this.removeItemSangria = function (row) {
		ItemSangria.findAll().then(function (item) {
			ScreenService.confirmMessage(
				'Deseja remover o item?', 'question',
				function () {
					_.remove(item, function (a) {
						return a.IDENTIFICADOR == row.selectedRow.IDENTIFICADOR;
					}.bind(this));
					row.owner.field.getParent().getParent().dataSource.data = item;
					ItemSangria.remove(Query.build()).then(function () {
						return ItemSangria.save(item);
					});
				},
				function () { }
			);
		});
	};

	this.clearPopUpSangria = function (widget, clearItems) {
		widget.getField('tipoRecebimento').clearValue();
		widget.getField('tipoSangria').clearValue();
		widget.getField('obsSangria').clearValue();
		widget.getField('valorSangria').clearValue();

		if (clearItems) {
			var item = [];
			widget.widgets[0].dataSource.data = item;
			ItemSangria.remove(Query.build()).then(function () {
				return ItemSangria.save(item);
			});
		}
	};

	this.saveSangria = function (widget) {
		ItemSangria.findAll().then(function (item) {
			if (widget.widgets[0].dataSource.data.length > 0) {
				ScreenService.confirmMessage(
					'Deseja imprimir o relatório?', 'question',
					function () {
						self.handleReturnSangria(item, true, widget);
					},
					function () {
						self.handleReturnSangria(item, false, widget);
					}
				);
			} else {
				ScreenService.showMessage('Nenhuma sangria foi selecionada.', 'alert');
			}
		});
	};

	this.handleReturnSangria = function (item, imprimeSangria, widget) {
		GeneralFunctionsService.saveSangria(item, imprimeSangria).then(function (retorno) {
			if (!_.isEmpty(retorno)) {
				if (!retorno[0].error) {
					if (!_.isEmpty(retorno[0].dadosImpressao)) {
						if(retorno[0].dadosImpressao.IDUTILIMPFRONT){
							var param = {};
							param.impressora = retorno[0].dadosImpressao.dadosImpressao;
							param.IDUTILIMPFRONT = retorno[0].dadosImpressao.IDUTILIMPFRONT;
							param.comandos = retorno[0].dadosImpressao.comandos;
							PerifericosService.print(param).then(function () {});
						} else {
							self.printSangriaSmartPos(retorno[0].dadosImpressao.sangria);
						}
					} else if (!_.isEmpty(retorno[0].mensagemImpressao)) {
						ScreenService.showMessage(retorno[0].mensagemImpressao, 'alert');
					}
					ScreenService.goBack();
				} else {
					ScreenService.showMessage(retorno[0].message, 'error');
				}
			}
		});
	};

	this.saveRow = function (widget) {
		row = widget.widgets[0];
		row.selectedRow = widget.currentRow;
	};

	this.printSangriaSmartPos = function (sangria) {
		PrinterService.printerCommand(PrinterService.TEXT_COMMAND, sangria);
		PrinterService.printerSpaceCommand();
		PrinterService.printerInit().then(function (result) {
			if (result.error) {
				ScreenService.alertNotification(result.message);
			}
		});
	};

	this.handleToggleLock = function () {
		PermissionService.checkAccess('bloqueiaDispositivo').then(function () {
			self.toggleLock();
		});
	};

	this.handleUnlockDevice = function (row) {
		cordova.plugins.KioskPOS.validateMasterSupervisor(row.supervisor, row.pass,
			function (unlock) {
				if (unlock)
					self.toggleLock();
				else
					ScreenService.showMessage("Senha incorreta.");
			}
		);
	};

	this.toggleLock = function () {
		ScreenService.showCustomDialog("A aplicação será reiniciada.", "alert", "exclamation", [
			{
				label: "OK",
				"default": true,
				code: function () {
					var kiosk = cordova.plugins.KioskPOS;
					kiosk.isInKiosk(function (isInKiosk) {
						if (isInKiosk)
							kiosk.unlockDevice(self.toggleLockResult, self.toggleLockResult);
						else
							kiosk.lockDevice(self.toggleLockResult, self.toggleLockResult);
					});
				}
			}, {
				label: "Cancelar",
				code: null
			}
		]);
	};

	this.toggleLockResult = function (result) {
		result = JSON.parse(result);

		if (result.error) {
			ScreenService.showMessage(result.message);
		}
	};

	this.closeUnlockPopup = function () {
		var widgetBase = templateManager.container.login || templateManager.containers.auth;
		var unlockDeviceWidget = widgetBase.getWidget("loginWidget").widgets[4];
		ScreenService.closePopup(true);
		unlockDeviceWidget.isVisible = false;
	};

	this.exportLogs = function (userInteration) {
		var instanciaTEF = window.getInstanciaTEF();
		if (instanciaTEF.exportLogs && 2==1) {
			userInteration = userInteration === undefined ? true : userInteration;
			if (userInteration) {
				ScreenService.showLoader();
			}
			instanciaTEF.exportLogs(function (javaResult) {
				if (javaResult.error) {
					if (userInteration) {
						ScreenService.hideLoader();
						ScreenService.showMessage(javaResult.message);
					}
				} else {
					GeneralFunctionsService.exportLogs(javaResult.content, device.serial).then(function (exportLogsResult) {
						if (userInteration) {
							ScreenService.hideLoader();
						}

						exportLogsResult = exportLogsResult[0];
						if (exportLogsResult.error) {
							if (userInteration) {
								ScreenService.showMessage(exportLogsResult.message);
							}
						} else {
							instanciaTEF.deleteLogs();
							if (userInteration) {
								ScreenService.showMessage("Logs exportados com sucesso.", 'success');
							}
						}
					}.bind(this));
				}
			});
		} else if(existe(window,"ZhSitefIntegration.exportLogs")) {
			window.ZhSitefIntegration.exportLogs();
		} else {
			ScreenService.showMessage("Envio de Logs ainda não foi implementado para este dispositivo.");
		}
	};

	this.reprintRedeCoupom = function () {
		if (!!window.cordova && !!cordova.plugins.GertecRede) {
			var params = {};
			cordova.plugins.GertecRede.reprint(JSON.stringify(params), self.reprintRedeCoupomResult, function () { });
		} else if(window.ZhRedeAutomation) {
			window.ZhRedeAutomation.reprint(JSON.stringify({}), self.reprintRedeCoupomResult, function () { });
		} else {
			self.reprintRedeCoupomResult(self.invalidIntegrationInstance());
		}
	};

	this.reprintRedeCoupomResult = function (javaResult) {
		if (javaResult === null) {
			ScreenService.showMessage(MESSAGE_NULL_RESPONSE);
		} else if (javaResult.error) {
			ScreenService.showMessage(javaResult.message);
		}
	};

	this.redeReversalPayment = function () {
		if (existe(window,"cordova.plugins.GertecRede") || window.ZhRedeAutomation ) {
			var params = {};
			IntegrationService.reversalIntegration(self.mochRemovePaymentSale, Array({ IDTPTEF: '4' })).then(self.redeReversalPaymentResult);
		} else {
			self.redeReversalPaymentResult(self.invalidIntegrationInstance());
		}
	};

	this.redeReversalPaymentResult = function (javaResult) {
		if (javaResult === null) {
			ScreenService.showMessage(MESSAGE_NULL_RESPONSE);
		} else if (javaResult.error) {
			ScreenService.showMessage(javaResult.message);
		} else {
			ScreenService.showMessage("TEF estornado com sucesso.", 'success');
		}
	};

	this.showDeviceSerial = function () {
		ScreenService.showMessage("O serial deste dispositivo é: " + device.serial, 'success');
	};

	this.checkPendingPayment = function() {
		var errorMessage = "Não foram encontrados pagamentos pendentes.";

		OperatorRepository.findOne().then(function(operatorData){
			OperatorController.checkPendingPayment(operatorData.IDTPTEF, errorMessage);
		}.bind(this));
	};

	this.showcontactUs = function () {
		var widgetBase = templateManager.container.login || templateManager.containers.auth;
		var contactInfoWidget = widgetBase.getWidget('contactInfo');
		ScreenService.openPopup(contactInfoWidget);
	};

	this.AtualizacaoDisponivel = function() {
		var query = Query.build()
			.where('chave').equals(operatorData.chave)
			.where('frontVersion').equals(projectConfig.frontVersion);
		return AtualizacaoDisponivel.download(query);
	};

	this.changeConnectionVisible = function (args) {
		var widgetBase = templateManager.containers.login || templateManager.containers.auth;
		var menusAdministracao = OperatorController.searchByName("administracao", templateManager.project.groupMenu);
		var enableSecondaryIPandPort = widgetBase.getWidget('serverIpWidget').currentRow.enableSecondaryIPandPort;

		OperatorController.searchByName("changeConnection", menusAdministracao.menus).isVisible = 
			((enableSecondaryIPandPort == 'S' || enableSecondaryIPandPort == 'Y') && 
				!_.isEmpty(widgetBase.getWidget('serverIpWidget').currentRow.ipSecundario));
	};

	this.showChangeConnection = function () {
		var widgetBase = templateManager.containers.login || templateManager.containers.auth;
		var changeConnectionWidget = widgetBase.getWidget('trocaConexao');

		var enableSecondaryIPandPort = widgetBase.getWidget('serverIpWidget').currentRow.enableSecondaryIPandPort;
		if((enableSecondaryIPandPort == 'S' || enableSecondaryIPandPort == 'Y') && !_.isEmpty(widgetBase.getWidget('serverIpWidget').currentRow.ipSecundario)) {
			changeConnectionWidget.fields[0].dataSource.data[0].name = 'Principal (Wi-Fi)';
			changeConnectionWidget.fields[0].dataSource.data[1].name = 'Secundário (4G)';

			var TIPOCONNEXAOField = changeConnectionWidget.getField('TIPOCONNEXAO');
			TIPOCONNEXAOField.clearValue();

			if(window.isGPRS) {
				TIPOCONNEXAOField.value('GPRS');
				TIPOCONNEXAOField.setValue('GPRS');
			} else {
				TIPOCONNEXAOField.value('WIFI');
				TIPOCONNEXAOField.setValue('WIFI');
			}
			
			TIPOCONNEXAOField.reload();
		}

		ScreenService.openPopup(changeConnectionWidget);
	};
	
	this.configToJson = function(resposta){
		try {
			if(!resposta){return null;}
			resposta = resposta.substring(resposta.indexOf("{"));
			resposta = resposta.substring(0,resposta.indexOf("}")+1);
			resposta = resposta.replaceAll("'",'"').replaceAll("\\n","").replaceAll("\\r","").replace(/[\n\r]/g,' ').replaceAll(" ","").replaceAll("	","");
			resposta = resposta.replaceAll(':','":').replaceAll(",",',"').replaceAll("{",'{"');
			resposta = JSON.parse(resposta);
			return (resposta);
		}catch(e){ }
		return null;
	};

	this.AtualizarVersao = function() {
		self.AtualizacaoDisponivel().then(function(resposta){
			resposta=resposta[0]||{};
			if(resposta.AtualizacaoDisponivel){
				ScreenService.confirmMessage(
                    'Versão '+resposta.AtualizacaoDisponivel+' esta disponível para download. Deseja atualizar agora?',
                    'question',
                    function () {
                        ScreenService.confirmMessage(
							"AVISO IMPORTANTE:<br><br>Este procedimento poderá levar vários minutos, e não poderá ser cancelado. Favor aguarde até que a atualização termine antes de realizar qualquer operação.",
							"alert",
							function (){
								ScreenService.changeLoadingMessage("Atualizando a versão. Isto pode levar vários minutos. Aguarde...");
								var query = Query.build()
									.where('chave').equals(operatorData.chave)
									.where('frontVersion').equals(resposta.AtualizacaoDisponivel);
								AtualizarVersao.download(query).then(
									function (updateResult){
										ConfigIpRepository.findOne().then(function(configIp){
											new Promise(function (resolve){
												if(configIp){
													$.ajax({"url":configIp.urlServidorFront+"/mobile/config.js", timeout: 9000}).then(function(resposta){
														resposta = self.configToJson(resposta)||{};
														resolve((resposta.frontVersion && resposta.serviceUrl)?resposta:false);
													}).fail(function(xhr, status, error){
														$.ajax({"url":configIp.urlServidorFront+"/config.js", timeout: 9000}).then(function(resposta){
															resposta = self.configToJson(resposta)||{};
															resolve((resposta.frontVersion && resposta.serviceUrl)?resposta:false);
														}).fail(function(xhr, status, error) {
															resolve(false);
														});
													});
												} else {
													resolve(false);
												}
											}).then(function(novoConfig){
												if(novoConfig){
													configIp.ipCompleto = configIp.ipForBack + novoConfig.serviceUrl;
													templateManager.updateURL(configIp.ipCompleto);
													configIp.serviceUrl = novoConfig.serviceUrl;
													return ConfigIpRepository.clearAll().then(function() {
														return ConfigIpRepository.save(configIp).then(function() {
															return configIp;
														});
													});
												}
											}).then(function(){
												ScreenService.restoreDefaultLoadingMessage();
												window.location.reload();
											});
										});
									},
									function (){
										ScreenService.restoreDefaultLoadingMessage();
									}
								);
							},
							function (){}
						);
                    },
                    function () { }
                );
			}
		});
	};

	this.loadTranfers = function (widget) {
		widget.dataSource.data = [];
		GeneralFunctionsService.loadTranfers().then(function (retorno) {
			if (widget.dataSource.data && widget.dataSource.data.length > 0) {
				widget.dataSource.data = [];
			}

			widget.dataSource.data = retorno;
			widget.reload();
		});
	};

	this.logForAPK = function(text) {
		GeneralFunctionsService.logForAPK(text);
	};

	window.logForAPK = self.logForAPK;
}

Configuration(function (ContextRegister) {
	ContextRegister.register('GeneralFunctions', GeneralFunctions);
});