function PrinterGPOS720(ScreenService){
	
	var self = this;

	var INVALID_PRINTER_INSTANCE = 'Não foi possível chamar a impressora. Sua instância não existe.';

	this.print = function(size){
		if (!!window.GPOS720Printer){
			if(!_.isEmpty(size)) GPOS720Printer.configurePrinter(size);
			else GPOS720Printer.configurePrinter();
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printText = function(text){
		if (!!window.GPOS720Printer){
			GPOS720Printer.printText(text);
			self.print();
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printQRCode = function(qrCode){
		self.printImage(qrCode, 1);
	};

	this.printBarCode = function(barCode){
		self.printImage(barCode, 2);
	};

	this.printImage = function(stringCode, type){
		// impressão de imagem utilizada pelo QRcode e Código de Barras
		if (!!window.GPOS720Printer){
			GPOS720Printer.printQrCode(stringCode);
			self.print();
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printerDelay = function(time){
		var returnObj = self.formatResponse();
		returnObj.error = false;
		window.returnPrintResult(JSON.stringify(returnObj));
	};

	this.reprintTEFVoucher = function(){
		window.returnPrintResult(self.invalidPrinterInstance());
	};

	this.printResult = function(resolve, javaResult){
		var response = self.formatResponse();

		response.error = javaResult.error;
		response.message = javaResult.message;
		response.errorCode = javaResult.errorCode;

		resolve(response);
	};

	this.invalidPrinterInstance = function(){
		return JSON.stringify({
            'error': true,
            'message': INVALID_PRINTER_INSTANCE
        });
    };

	this.formatResponse = null;
	
}

Configuration(function(ContextRegister) {
	ContextRegister.register('PrinterGPOS720', PrinterGPOS720);
});