function PrinterGertec(ScreenService){
	
	var self = this;

	var INVALID_PRINTER_INSTANCE = 'Não foi possível chamar a impressora. Sua instância não existe.';

	this.getInstance = function() {
		if (!!window.ZhGertecPrinter){
			self.instance = window.ZhGertecPrinter;
		} else if(!!window.cordova && !!cordova.plugins.GertecPrinter) {
			self.instance = cordova.plugins.GertecPrinter;
		} else return false;
		return true;
	};

	this.initPrinter = function(textSize){
		if (!_.isEmpty(textSize) && textSize < 17) textSize = '17';

		if (self.getInstance()){
			self.instance.initPrinter();
			if(!_.isEmpty(textSize)) self.instance.configurePrinter(textSize);
			else self.instance.configurePrinter();
		} else {
			if (window.returnPrintResult != null){
				window.returnPrintResult(self.invalidPrinterInstance());
			}
		}
	};
	
	this.printText = function(text){
		if (self.getInstance()){
			try {self.instance.printText(text);}
			catch(e) {
				try {self.instance.printString(text, window.returnPrintResult, function(){});}
				catch(err) {window.returnPrintResult(self.invalidPrinterInstance());}
			}
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printQRCode = function(qrCode){
		if (self.getInstance()){
			try {self.instance.printQrCode(qrCode);}
			catch(e) {
				try {self.instance.printQrCode(qrCode, window.returnPrintResult, function(){});}
				catch(err) {window.returnPrintResult(self.invalidPrinterInstance());}
			}
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printBarCode = function(barCode){
		if (self.getInstance()){
			try {self.instance.printBarCode(barCode);}
			catch(e) {
				try {self.instance.printBarCode(barCode, window.returnPrintResult, function(){});}
				catch(err) {window.returnPrintResult(self.invalidPrinterInstance());}
			}
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printerDelay = function(time){
		setTimeout(function(){
			var returnObj = self.formatResponse();
			returnObj.error = false;
			window.returnPrintResult(JSON.stringify(returnObj));
		}, parseInt(time));	
	};

	this.reprintTEFVoucher = function(){
		window.returnIntegration = _.bind(self.getReprintTextResult, this);

		if (self.getInstance()){
			self.instance.showAdministrativeMenu();
		} else {
			window.returnIntegration(self.invalidPrinterInstance());
		}
	};

	this.getReprintTextResult = function(javaResult){
		window.returnPrintResult = _.bind(self.reprintResult, this);
		javaResult = JSON.parse(javaResult);
		var comandos = [javaResult.customerReceipt, "", ""];

		if(javaResult.paymentTransactionStatus === 0) {
			comandos.forEach(function(text) {
				self.printText(text);
			}.bind(this));
		} else {
			ScreenService.showMessage("Erro ao tentar encontrar o último comprovante TEF");
		}
	};

	this.reprintResult = function (javaResult) {
		javaResult = JSON.parse(javaResult);

		if(javaResult.paymentTransactionStatus === 1) {
			ScreenService.showMessage("Erro ao imprimir o último comprovante TEF");
		}
	};

	this.printResult = function(resolve, javaResult){
		if (self.getInstance() && typeof(javaResult) === 'string') javaResult = JSON.parse(javaResult);

		resolve(javaResult);
	};

	this.invalidPrinterInstance = function(){
		return JSON.stringify({
            'error': true,
            'message': INVALID_PRINTER_INSTANCE
        });
    };

	this.formatResponse = null;
	
}

Configuration(function(ContextRegister) {
	ContextRegister.register('PrinterGertec', PrinterGertec);
});