function EventManager() {
	var self = this;

	this.eventId = null;
	this.startTime = null;
	this.backgroundProcess = false;

	this.start = function(eventId) {
		this.eventId = eventId;
		this.startTime = new Date();
		this.lockExecution();
	};

	this.stop = function() {
		this.eventId = null;
		this.startTime = null;
		this.releaseExecution();
	};

	this.lockExecution = function() {
		this.backgroundProcess = true;
	};

	this.releaseExecution = function() {
		this.backgroundProcess = false;
	};

	this.isAvailableForExecution = function(){
		return !this.backgroundProcess;
	};

	this.hasEventInProgress = function() {
		return !!this.eventId;
	};

	this.getCurrentEvent = function() {
		var hasEvent = this.hasEventInProgress();
		var event = {
			eventId: this.eventId,
			startTime: this.startTime,
		};
		return hasEvent ? event : null;
	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register("EventManager", EventManager);
});
